<id>
Email Via Forum for YaBB 2.4
</id>

<version>
0.3
</version>

<mod info>
Description
-----------
This Mod will allow Members to send emails to other Members via the Forum. 

Installation
------------
1) Modify YaBB files using BoardMod or manually.
2) Upload modified files to your server in ASCII mode.
3) Upload SendEmail.lng to the relevant Languages directory in ASCII mode.
4) Upload SendEmail.pl to the Sources directory in ASCII mode.
5) Go to 'Admin Center => Advanced Settings => Email' and check 'Enable Emails to be sent via the forum' to enable this feature.

Files to edit
-------------
Admin/ModList.pl
Admin/NewSettings.pl
Admin/Settings_Advanced.pl
Languages/English/Admin.lng
Languages/English/Email.lng
Languages/English/Profile.lng
Sources/Display.pl
Sources/Load.pl
Sources/MemberList.pl
Sources/MyCenter.pl
Sources/Profile.pl
Sources/SubList.pl
Sources/System.pl

Version History
---------------
V0.1 - First release - 5th May 2010
V0.2 - Added Member Group permissions and Member profile option - 9th May 2010
V0.3 - Added Member option to receive emails via the forum even if their email is hidden - 25th May 2010
</mod info>

<author>
Derek Barnstorm
</author>

<homepage>
http://www.boardmod.org
</homepage>

<edit file>
Admin/ModList.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
	$email_via_forum = "Email Via Forum|Derek Barnstorm|This Mod will allow Members to send emails to other Members via the Forum.|0.3|25th May 2010";
	push (@installed_mods, "$email_via_forum");
	
</add before>

<edit file>
Admin/NewSettings.pl
</edit file>

<search for>
########## In-Thread Multi Delete ##########
</search for>

<add before>
### Email Via Forum Mod Start ###							
\$send_email = $send_email;   # Set to 1 to enable members to send emails via YaBB
\$send_email_group = "\Q$send_email_group\E";   # Member Groups allowed to send emails via YaBB: '' == all members
### Email Via Forum Mod End ###

</add before>

<edit file>
Admin/Settings_Advanced.pl
</edit file>

<search for>
if ($action eq 'detailedversion') { return 1; }
</search for>

<add after>

### Email Via Forum Mod Start ### 
require "$admindir/ManageBoards.pl"; # needed for send email group permissions setting
### Email Via Forum Mod End ###
</add after>

<search for>
			name => 'sendtopicmail',
			validate => 'number',
		},
</search for>

<add after>
		### Email Via Forum Mod Start ###
		{
			header => $admin_txt{'send_email_1'},
		},
		{
			description => $admin_txt{'send_email_2'},
			input_html => qq~<input type="checkbox" name="send_email" value="1" ${ischecked($send_email)}/>~,
			name => 'send_email',
			validate => 'boolean',
		},
		{
			description => $admin_txt{'send_email_3'},
			input_html => qq~<select multiple="multiple" name="send_email_group" size="8">~ . &DrawPerms($send_email_group, 0) . qq~</select>~,
			name => 'send_email_group',
			validate => 'text,null',
			depends_on => ['send_email'],
		},
		### Email Via Forum Mod End ###
</add after>

<edit file>
Languages/English/Admin.lng
</edit file>

<search for>
);

%floodtxt = (
</search for>

<add before>
### Email Via Forum Mod Start ###
'send_email_1' => 'Member Email Settings',
'send_email_2' => 'Enable Members to send emails via the forum?',
'send_email_3' => 'Specify the Member Groups that will be enabled to send emails via the forum:<br /><span class ="small">If no Member Groups are selected all Member Groups will be enabled.<br />Use Ctrl, Shift or Apple Key to select/deselect groups.</span>',
### Email Via Forum Mod End ###
</add before>

<search for>
'2' => 'Activate Validation code on registration, forgot password, and send topic',
</search for>

<replace>
'2' => 'Activate Validation code on registration, forgot password, send topic and send email',
</replace>

<edit file>
Languages/English/Email.lng
</edit file>

<search for>
1;
</search for>

<add before>
### Email Via Forum Mod Start ###
$sendemail = qq~Hello {yabb recipientname},

This email has been sent to you by {yabb yourname} via your account on {yabb mbname}.

If this message is spam or contains abusive or offensive content, please contact the Administrator of the Forum.

Regards,

The {yabb mbname} team
{yabb scripturl}

The message is as follows:
-----------------------------
Subject: {yabb emailsubject}
Message: 
{yabb emailmessage}~;

$sendemail_selfcopy = qq~Hello {yabb yourname},

This is the requested self copy of an email which you have recently sent to {yabb recipientname} via your account on {yabb mbname}.

Regards,

The {yabb mbname} team
{yabb scripturl}

The message is as follows:
-----------------------------
Subject: {yabb emailsubject}
Message: 
{yabb emailmessage}~;
### Email Via Forum Mod End ###

</add before>

<edit file>
Languages/English/Profile.lng
</edit file>

<search for>
);

%mycenter_profile_txt = (
</search for>

<add before>
### Email Via Forum Mod Start ###
'send_email_1' => 'Can Members Email you via the Forum?',
'send_email_2' => '- If you hide your email from the public, by checking this option you can still allow members to email you via the forum.<br />- Members must have permission to use this feature and must also have it enabled in their profile.<br />- Your email address will be hidden from them.',
'send_email_3' => 'Send Emails via the Forum?',
'send_email_4' => 'Leave unchecked to send emails via your own email program.',
### Email Via Forum Mod End ###
</add before>

<edit file>
Sources/Display.pl
</edit file>

<search for>
		if ((!${$uid.$musername}{'hidemail'} || $iamadmin || $allow_hide_email != 1 || $musername eq 'Guest') && !$exmem) {
			$template_email = $menusep . &enc_eMail($img{'email_sm'},$memail,'','');
		}
</search for>

<replace>
	    ### Email Via Forum Mod Edit Start ###
	    &SendEmailPerms;
		if ((!${$uid.$musername}{'hidemail'} || $iamadmin || $allow_hide_email != 1 || $musername eq 'Guest' || ($send_email && $allow_send_email && ${$uid.$musername}{'hidemail'} && ${$uid.$musername}{'en_re_email'} && ${$uid.$username}{'en_send_email'})) && !$exmem) {
            if ($send_email && $allow_send_email && ${$uid.$username}{'en_send_email'} && $musername ne 'Guest') {
		        $template_email = qq~$menusep<a href="$scripturl?action=sendemail;to=$useraccount{$musername}">$img{'email_sm'}</a>~;
		    } else {
			    $template_email = $menusep . &enc_eMail($img{'email_sm'},$memail,'','');
			}
		}
		### Email Via Forum Mod Edit End ###
</replace>

<edit file>
Sources/Load.pl
</edit file>

<search for>
sub LoadUserSettings {
</search for>

<add before>
### Email Via Forum Mod Start ###
sub SendEmailPerms {
    if ($send_email && $send_email_group) {
		$allow_send_email = 0;
		foreach my $email_group (split(/, /, $send_email_group)) {
			if (($email_group eq ${$uid.$username}{'position'}) || ($email_group eq $memberunfo{$username})) { $allow_send_email = 1; last; }
			foreach (split(/,/, ${$uid.$username}{'addgroups'})) {
				if ($email_group eq $_) { $allow_send_email = 1; last; }
			}
	    }
	} else { 
        $allow_send_email = 1; 
    }
}
### Email Via Forum Mod End ###

</add before>

<search for>
			if (!${$uid.$user}{'hidemail'} || $iamadmin) {
				$quicklinks .= "				<li>" . &enc_eMail("$maintxt{'1'} ${$uid.$user}{'realname'}",${$uid.$user}{'email'},'','') . "</li>\n";
			}
</search for>

<replace>
			### Email Via Forum Mod Edit Start ###
			&SendEmailPerms;
			if (!${$uid.$user}{'hidemail'} || $iamadmin || ($send_email && $allow_send_email && ${$uid.$user}{'hidemail'} && ${$uid.$user}{'en_re_email'} && ${$uid.$username}{'en_send_email'})) {
			    if ($send_email && $allow_send_email && ${$uid.$username}{'en_send_email'}) {
			        $quicklinks .= qq~          <li><a href="$scripturl?action=sendemail;to=$useraccount{$user}">$maintxt{'1'} ${$uid.$user}{'realname'}</a></li>\n~;
		        } else {
				    $quicklinks .= "			<li>" . &enc_eMail("$maintxt{'1'} ${$uid.$user}{'realname'}",${$uid.$user}{'email'},'','') . "</li>\n";
				}
			}
			### Email Via Forum Mod Edit End ###
</replace>

<edit file>
Sources/MemberList.pl
</edit file>

<search for>
		if (${$uid.$user}{'hidemail'} && !$iamadmin && $allow_hide_email == 1) {
			$yymain .= qq~
			<td align="center" class="windowbg2"><img src="$imagesdir/lockmail.gif" alt="Hidden Email" /></td>
		~;
</search for>

<replace>
		### Email Via Forum Mod Edit Start ###
		&SendEmailPerms;
		if ((!${$uid.$user}{'hidemail'} && $send_email && $allow_send_email && ${$uid.$username}{'en_send_email'}) || (${$uid.$user}{'hidemail'} && ${$uid.$user}{'en_re_email'} && $send_email && $allow_send_email && ${$uid.$username}{'en_send_email'}) || ($iamadmin && $send_email && $allow_send_email && ${$uid.$username}{'en_send_email'})) {
		    $yymain .= qq~
			<td align="center" class="windowbg2"><a href="$scripturl?action=sendemail;to=$useraccount{$user}"><img src="$imagesdir/email.gif" border="0" alt="$img_txt{'69'}" title="$img_txt{'69'}" /></a></td>
			~;
		} elsif (${$uid.$user}{'hidemail'} && !$iamadmin && $allow_hide_email == 1) {
			$yymain .= qq~
			<td align="center" class="windowbg2"><img src="$imagesdir/lockmail.gif" alt="Hidden Email" /></td>
		~;
		### Email Via Forum Mod Edit End ###
</replace>

<edit file>
Sources/MyCenter.pl
</edit file>

<search for>
			if (!${$uid.$usrname}{'hidemail'} || $iamadmin || $iamgmod || $allow_hide_email != 1) {
				$sendEmail = qq~$menusep<a href="mailto:${$uid.$usrname}{'email'}">$img{'email_sm'}</a>~;
			}
</search for>

<replace>

            ### Email Via Forum Mod Edit Start ###
            &SendEmailPerms;
			if (!${$uid.$usrname}{'hidemail'} || $iamadmin || $iamgmod || $allow_hide_email != 1 || ($send_email && $allow_send_email && ${$uid.$usrname}{'hidemail'} && ${$uid.$usrname}{'en_re_email'} && ${$uid.$username}{'en_send_email'})) {
			    if ($send_email && $allow_send_email && ${$uid.$username}{'en_send_email'}) {
			        $sendEmail = qq~$menusep<a href="$scripturl?action=sendemail;to=$useraccount{$usrname}">$img{'email_sm'}</a>~;
			    } else {
				    $sendEmail = qq~$menusep<a href="mailto:${$uid.$usrname}{'email'}">$img{'email_sm'}</a>~;
				}
			}
            ### Email Via Forum Mod Edit End ###
</replace>

<search for>
			if (${$uid.$buddyname}{'hidemail'} && !$iamadmin && $allow_hide_email == 1) {
				$buddyemail = qq~<img src="$imagesdir/lockmail.gif" alt="Hidden Email" title="Hidden Email" />~;
</search for>

<replace>
            ### Email Via Forum Mod Edit Start ###
            &SendEmailPerms;
			if ((!${$uid.$buddyname}{'hidemail'} && $send_email && $allow_send_email && ${$uid.$username}{'en_send_email'}) || (${$uid.$buddyname}{'hidemail'} && ${$uid.$buddyname}{'en_re_email'} && $send_email && $allow_send_email && ${$uid.$username}{'en_send_email'}) || ($iamadmin && $send_email && $allow_send_email && ${$uid.$username}{'en_send_email'})) {
			    $buddyemail = qq~<a href="$scripturl?action=sendemail;to=$useraccount{$buddyname}"><img src="$imagesdir/email.gif" border="0" alt="$profile_txt{'889'} ${$uid.$buddyname}{'realname'}" title="$profile_txt{'889'} ${$uid.$buddyname}{'realname'}" /></a>~;
			} elsif (${$uid.$buddyname}{'hidemail'} && !$iamadmin && $allow_hide_email == 1) {
				$buddyemail = qq~<img src="$imagesdir/lockmail.gif" alt="Hidden Email" title="Hidden Email" />~;
			### Email Via Forum Mod Edit End ###
</replace>

<edit file>
Sources/Profile.pl
</edit file>

<search for>
		<td align="left"><input type="checkbox" name="hideemail" id="hideemail" value="1"$checked /></td>
	</tr>~;
	}
</search for>

<add after>
	### Email Via Forum Mod Start ###
	if ($send_email && $allow_hide_email) {
		$showProfile .= qq~
	<tr class="windowbg">
		<td align="left"><label for="en_re_email"><b>$profile_txt{'send_email_1'}</b><br /><span class="small">$profile_txt{'send_email_2'}</span></label></td>
		<td align="left" valign="top"><input type="checkbox" name="en_re_email" id="en_re_email"~ . (${$uid.$user}{'en_re_email'} ? qq~ checked="checked"~ : '') . qq~ /></td>
	</tr>~;
	}
	### Email Via Forum Mod End ###
</add after>

<search for>
	foreach my $curtemplate (sort{ $templateset{$a} cmp $templateset{$b} } keys %templateset) {
</search for>

<add before>
    ### Email Via Forum Mod Edit Start ###
    &SendEmailPerms;
	if ($send_email && $allow_send_email) {
		$showProfile .= qq~
	<tr class="windowbg">
		<td align="left"><label for="en_send_email"><b>$profile_txt{'send_email_3'}</b><br /><span class="small">$profile_txt{'send_email_4'}</span></label></td>
		<td align="left" valign="top"><input type="checkbox" name="en_send_email" id="en_send_email"~ . (${$uid.$user}{'en_send_email'} ? qq~ checked="checked"~ : '') . qq~ /></td>
	</tr>~;
	}
	### Email Via Forum Mod End ###
	
</add before>

<search for>
	${$uid.$user}{'hidemail'} = $member{'hideemail'} ? 1 : 0;
</search for>

<add after>
	### Email Via Forum Mod Start ###
	${$uid.$user}{'en_re_email'} = $member{'en_re_email'} ? 1 : 0;
	### Email Via Forum Mod End ###
</add after>

<search for>
	${$uid.$user}{'timeformat'} = $member{'timeformat'};
</search for>

<add after>
	### Email Via Forum Mod Start ###
	${$uid.$user}{'en_send_email'} = $member{'en_send_email'} ? 1 : 0;
	### Email Via Forum Mod End ###
</add after>

<search for>
	if (!${$uid.$user}{'hidemail'} || $iamadmin || !$allow_hide_email || $view) {
		my $rowEmail = '';
		if ($view) {
			if (!${$uid.$user}{'hidemail'}) {
				$rowEmail = $profile_txt{'showingemail'};
			} else {
				my ($admtitle, undef) = split(/\|/, $Group{'Administrator'}, 2);
				$rowEmail = qq~$profile_txt{'notshowingemail'} $admtitle$profile_txt{'notshowingemailend'}~;
			}
</search for>

<replace>
    ### Email Via Forum Mod Edit Start ###
    &SendEmailPerms;
	if (!${$uid.$user}{'hidemail'} || $iamadmin || !$allow_hide_email || $view || ($send_email && $allow_send_email && ${$uid.$user}{'hidemail'} && ${$uid.$user}{'en_re_email'} && ${$uid.$username}{'en_send_email'})) {
		my $rowEmail = '';
		if ($view) {
			if (!${$uid.$user}{'hidemail'}) {
				$rowEmail = $profile_txt{'showingemail'};
			} else {
				my ($admtitle, undef) = split(/\|/, $Group{'Administrator'}, 2);
				$rowEmail = qq~$profile_txt{'notshowingemail'} $admtitle$profile_txt{'notshowingemailend'}~;
			}
        } elsif ($send_email && $allow_send_email && ${$uid.$username}{'en_send_email'}) {
			$rowEmail = qq~<a href="$scripturl?action=sendemail;to=$useraccount{$user}">$profile_txt{'889'} ${$uid.$user}{'realname'}</a>~;
    ### Email Via Forum Mod Edit End ###
</replace>

<edit file>
Sources/SubList.pl
</edit file>

<search for>
'search2',"Search.pl&plushSearch2",
</search for>

<add after>
### Email Via Forum Mod Start ###
'sendemail',"SendEmail.pl&SendEmail",
'sendemail2',"SendEmail.pl&SendEmail2",
### Email Via Forum Mod End ###
</add after>

<edit file>
Sources/System.pl
</edit file>

<search for>
	if ($extendedprofiles) {
		require "$sourcedir/ExtendedProfiles.pl";
		push(@tags, &ext_get_fields_array());
	}
</search for>

<add before>
	### Email Via Forum Mod Start ###
	push(@tags, "en_re_email", "en_send_email");
	### Email Via Forum Mod End ###
</add before>

