###############################################################################
# SendEmail.pl                                                                #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 2.4                                                    #
# Packaged:       April 12, 2009                                              #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2009 YaBB (www.yabbforum.com) - All Rights Reserved.     #
# Software by:  The YaBB Development Team                                     #
#               with assistance from the YaBB community.                      #
# Sponsored by: Xnull Internet Media, Inc. - http://www.ximinc.com            #
#               Your source for web hosting, web design, and domains.         #
###############################################################################

$sendemailplver = 'YaBB 2.4 $Revision: 0.3 $';
if ($action eq 'detailedversion') { return 1; }

require "$sourcedir/SpamCheck.pl";

&LoadLanguage('SendEmail'); 

&SendEmailPerms;

&fatal_error("not_allowed") if (!$send_email || !$allow_send_email || $iamguest || !${$uid.$username}{'en_send_email'});

sub SendEmail { 

    $user = $INFO{'to'};
    unless (&LoadUser($user)) { &fatal_error('no_profile_exists'); }
    
    &fatal_error("not_allowed") if (${$uid.$user}{'hidemail'} && $allow_hide_email && !${$uid.$user}{'en_re_email'} && !$iamadmin);
    
    $member_email = &enc_eMail(${$uid.$user}{'email'},${$uid.$user}{'email'},'','');
    if ($iamadmin) { $show_member_email = qq~($member_email)~; }

	# SpellChecker start
	if ($enable_spell_check) {
		$yyinlinestyle .= qq~<link href="$yyhtml_root/googiespell/googiespell.css" rel="stylesheet" type="text/css" />
<script type="text/javascript" src="$yyhtml_root/AJS.js"></script>
<script type="text/javascript" src="$yyhtml_root/googiespell/googiespell.js"></script>
<script type="text/javascript" src="$yyhtml_root/googiespell/cookiesupport.js"></script>~;
		my $userdefaultlang = (split(/-/, $abbr_lang))[0];
		$userdefaultlang ||= 'en';
		$send_email_spellcheck .= qq~
		GOOGIE_DEFAULT_LANG = '$userdefaultlang';
		var googie1 = new GoogieSpell("$yyhtml_root/googiespell/", "$boardurl/Sources/SpellChecker.pl?lang=");
		googie1.lang_chck_spell = '$spell_check{'chck_spell'}';
		googie1.lang_revert = '$spell_check{'revert'}';
		googie1.lang_close = '$spell_check{'close'}';
		googie1.lang_rsm_edt = '$spell_check{'rsm_edt'}';
		googie1.lang_no_error_found = '$spell_check{'no_error_found'}';
		googie1.lang_no_suggestions = '$spell_check{'no_suggestions'}';
		googie1.setSpellContainer("spell_container");
		googie1.decorateTextarea("email_message");~;
		$send_email_spelldiv = qq~<div id="spell_container" style="clear: left; float: left;"></div>~;
	}
	# SpellChecker end

	$yymain .= qq~
<form action="$scripturl?action=sendemail2" method="post" name="creator" onsubmit="return CheckEmailFields();">
  <table width="100%" align="center" border="0" cellpadding="4" cellspacing="1" class="bordercolor" >
	<colgroup>
      <col width="25%" />
      <col width="75%" />
	</colgroup>
	<tr>
	  <td align="left" colspan="2" class="catbg">
	    <img src="$imagesdir/email.gif" border="0" alt="" style="vertical-align: middle;" /> <span class="text1"><b>$sendemail_txt{'01'} ${$uid.$user}{'realname'}</b></span>
	  </td>
    </tr>
	<tr>
	  <td class="windowbg" align="right" valign="top">
	    <label><b>$sendemail_txt{'02'}:</b></label>
	  </td>
		<td class="windowbg2">
		  $link{$user} $show_member_email
		</td>
	</tr>
	<tr>
	  <td class="windowbg" align="right" valign="top">
	    <label for="email_subject"><b>$sendemail_txt{'03'}:</b></label>
	  </td>
	  <td class="windowbg2">
	    <input type="text" name="email_subject" id="email_subject" size="50" maxlength="80" style="width: 400px;" />
	  </td>
	</tr>
	<tr>
	  <td class="windowbg" align="right" valign="top">
	    <label for="email_message"><b>$sendemail_txt{'04'}:</b></label>
	  </td>
	  <td class="windowbg2">
	    <div style="float: left;">
		  <textarea cols="60" rows="15" name="email_message" id="email_message" style="width: 550px;"></textarea>
		</div>
		$send_email_spelldiv
	  </td>
	</tr>
	<tr>
	  <td class="windowbg" align="right" valign="top">
	    <label for="email_selfcopy"><b>$sendemail_txt{'05'}</b></label>
	  </td>
	  <td class="windowbg2">
        <input type="checkbox" name="email_selfcopy" id="email_selfcopy" />
	  </td>
	</tr>~;
	if ($regcheck && !$iamadmin && !$iamgmod) {
	    require "$sourcedir/Decoder.pl";
	    &validation_code;
        $yymain .= qq~
	<tr>
	  <td class="windowbg" align="right" valign="top">
	    <label for="verification"><b>$floodtxt{'1'}:</b><br /><span class="small">$floodtxt{'casewarning'}</span></label>
	  </td>
	  <td class="windowbg2" valign="middle">
	    $showcheck
	  </td>
	</tr>
	<tr>
	  <td class="windowbg" align="right" valign="top">
	    <label for="verification"><b>$floodtxt{'3'}:</b></label>
	  </td>
	  <td class="windowbg2">
	    <input type="text" maxlength="30" name="verification" id="verification" size="30" />
	  </td>
	</tr>~;
	}
	$yymain .= qq~
	<tr>
	  <td class="windowbg" colspan="2" align="center">
	    <span class="small">$sendemail_txt{'06'}: ${$uid.$username}{'email'}</span>
	  </td>
	<tr>
	  <td class="catbg" colspan="2" height="50" valign="middle" align="center">
	    <input type="hidden" name="username" value="$useraccount{$user}" />
		<input type="submit" value="$sendemail_txt{'07'}" accesskey="s" class="button" />
      </td>
	</tr>
</table>
</form>

	    <script type="text/javascript" language="JavaScript">
		<!--
		
        document.creator.email_subject.focus();
		
        function CheckEmailFields() {
        
		if (document.creator.email_subject.value == '') {
			alert("$sendemail_txt{'08'}");
			document.creator.email_subject.focus();
			return false;
		}
        if (document.creator.email_message.value == '') {
			alert("$sendemail_txt{'09'}");
			document.creator.email_message.focus();
			return false;
		}~ .
	    ($regcheck && !$iamadmin && !$iamgmod ? qq~
		if (document.creator.verification.value == '') {
			alert("$sendemail_txt{'10'}");
			document.creator.verification.focus();
			return false;
		}~ : '') . qq~
		
        return true;
    	}
        $send_email_spellcheck
   
		// -->
		</script>~;
	
	$yytitle = "$sendemail_txt{'01'} ${$uid.$user}{'realname'}";
	$yynavigation = qq~&rsaquo; $sendemail_txt{'07'}~;
	&template;
}

sub SendEmail2 {

    $user = $FORM{'username'};
    unless (&LoadUser($user)) { &fatal_error('no_profile_exists'); } 

    require "$sourcedir/Mailer.pl";
    &LoadLanguage('Email');

    $recipientname = ${$uid.$user}{'realname'};
	$recipientemail = ${$uid.$user}{'email'};
    $yourname = ${$uid.$username}{'realname'};
	$youremail = ${$uid.$username}{'email'};
    $emailsubject = $FORM{'email_subject'};
	$emailmessage = $FORM{'email_message'};
	$emailselfcopy = $FORM{'email_selfcopy'};
	$yourname =~ s/\A\s+//;
	$yourname =~ s/\s+\Z//;
	$youremail =~ s/\A\s+//;
	$youremail =~ s/\s+\Z//;
	$emailmessage =~ s/\r(?=\n*)//g;
    
    &fatal_error("no_subject") if ($emailsubject eq '');
	&fatal_error("no_message") if ($emailmessage eq '');
	
	if ($regcheck && !$iamadmin && !$iamgmod) { 
	    require "$sourcedir/Decoder.pl";
        &validation_check($FORM{'verification'}); 
    }

    # Spam detection start
	my $spamdetected = &spamcheck("$emailsubject $emailmessage");
	if (!${$uid.$FORM{$username}}{'spamcount'}) { ${$uid.$FORM{$username}}{'spamcount'} = 0; }
	if (!$iamadmin && !$iamgmod && !$iammod) {
        if ($spamdetected == 1) {
            ${$uid.$username}{'spamcount'}++;
            ${$uid.$username}{'spamtime'} = $date;
            &UserAccount($username,"update");
            $spam_hits_left_count = $post_speed_count - ${$uid.$username}{'spamcount'};
            &fatal_error("tsc_alert");
        }
    }
	# Spam detection end
    
    my $email_message = &template_email($sendemail, {'recipientname' => $recipientname, 'yourname' => $yourname, 'emailsubject' => $emailsubject, 'emailmessage' => $emailmessage});
	   &sendmail($recipientemail, "$emailsubject", $email_message, "$yourname <$youremail>"); 
 
	if ($emailselfcopy) {
	my $copy_emailmessage = &template_email($sendemail_selfcopy, {'yourname' => $yourname, 'recipientname' => $recipientname, 'emailsubject' => $emailsubject, 'emailmessage' => $emailmessage});
	   &sendmail($youremail, "$emailsubject", $copy_emailmessage, "$mbname <$webmaster_email>");
	}	
    
    $yymain .= qq~
<table width="100%" align="center" border="0" cellpadding="4" cellspacing="1" class="bordercolor">
  <tr>
    <td align="left" class="catbg">
	  <img src="$imagesdir/email.gif" border="0" alt="" style="vertical-align: middle;" /> <span class="text1"><b>$sendemail_txt{'11'} $recipientname</b></span>
	</td>
  </tr>
  <tr>
	<td class="windowbg" align="center" valign="middle" style="padding: 20px;">
	  <b>$sendemail_txt{'12'} $link{$user}.</b>
	  <p>&bull; <a href="$scripturl">$sendemail_txt{'13'}</a></p>
	  <span class="small">$sendemail_txt{'14'}</span>
    </td>
  </tr>
</table>~;

    $yyinlinestyle = qq~<meta http-equiv="refresh" content="4; url=$scripturl" />~;
	$yytitle = "$sendemail_txt{'11'} $recipientname";
	$yynavigation = qq~&rsaquo; $sendemail_txt{'15'}~;
	&template;
}

1;